/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
	"time"
)

// checks if the ContactCreatable type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ContactCreatable{}

// ContactCreatable struct for ContactCreatable
type ContactCreatable struct {
	// Profile name. Contacts created automatically out of conversations have messenger profile name here
	Name string `json:"name"`
	// Contact timezone in IANA format
	Timezone *string `json:"timezone,omitempty"`
	// Mobile number in E.164 format
	Mobile *string `json:"mobile,omitempty"`
	// NOT EDITABLE VIA API  Flag to mark mobile number as verified
	MobileVerified *bool `json:"mobile_verified,omitempty"`
	FirstName *string `json:"first_name,omitempty"`
	LastName *string `json:"last_name,omitempty"`
	Email *string `json:"email,omitempty"`
	Gender *string `json:"gender,omitempty"`
	// Birthdate in format specified in organization settings. Default is yyyy-mm-dd
	Birthdate *string `json:"birthdate,omitempty"`
	// Overriden with birthdate data if provided
	MonthOfBirth *int32 `json:"month_of_birth,omitempty"`
	// Overriden with birthdate data if provided
	DayOfBirth *int32 `json:"day_of_birth,omitempty"`
	Address *ContactAddress `json:"address,omitempty"`
	// NOT EDITABLE VIA API  Stores loyalty points of a contact
	LoyaltyPoints *map[string]int32 `json:"loyalty_points,omitempty"`
	// NOT EDITABLE VIA API  Stores lifetime loyalty points of a contact
	LifetimeLoyaltyPoints *map[string]int32 `json:"lifetime_loyalty_points,omitempty"`
	Languages *ContactLanguages `json:"languages,omitempty"`
	CareOf *string `json:"care_of,omitempty"`
	// JSON with custom properties as defined in organization settings. Format: { [propertyName]: { type: [string|float|bool|date|datetime], value: [propertyValue] } }
	StrictAttributes map[string]interface{} `json:"strict_attributes,omitempty"`
	// NOT EDITABLE VIA API
	MobileVerifiedAt *time.Time `json:"mobile_verified_at,omitempty"`
	Avatars *ContactAvatars `json:"avatars,omitempty"`
	// NOT EDITABLE VIA API
	ExternalIds map[string]interface{} `json:"external_ids,omitempty"`
}

// NewContactCreatable instantiates a new ContactCreatable object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewContactCreatable(name string) *ContactCreatable {
	this := ContactCreatable{}
	this.Name = name
	return &this
}

// NewContactCreatableWithDefaults instantiates a new ContactCreatable object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewContactCreatableWithDefaults() *ContactCreatable {
	this := ContactCreatable{}
	return &this
}

// GetName returns the Name field value
func (o *ContactCreatable) GetName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Name
}

// GetNameOk returns a tuple with the Name field value
// and a boolean to check if the value has been set.
func (o *ContactCreatable) GetNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Name, true
}

// SetName sets field value
func (o *ContactCreatable) SetName(v string) {
	o.Name = v
}

// GetTimezone returns the Timezone field value if set, zero value otherwise.
func (o *ContactCreatable) GetTimezone() string {
	if o == nil || IsNil(o.Timezone) {
		var ret string
		return ret
	}
	return *o.Timezone
}

// GetTimezoneOk returns a tuple with the Timezone field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactCreatable) GetTimezoneOk() (*string, bool) {
	if o == nil || IsNil(o.Timezone) {
		return nil, false
	}
	return o.Timezone, true
}

// HasTimezone returns a boolean if a field has been set.
func (o *ContactCreatable) HasTimezone() bool {
	if o != nil && !IsNil(o.Timezone) {
		return true
	}

	return false
}

// SetTimezone gets a reference to the given string and assigns it to the Timezone field.
func (o *ContactCreatable) SetTimezone(v string) {
	o.Timezone = &v
}

// GetMobile returns the Mobile field value if set, zero value otherwise.
func (o *ContactCreatable) GetMobile() string {
	if o == nil || IsNil(o.Mobile) {
		var ret string
		return ret
	}
	return *o.Mobile
}

// GetMobileOk returns a tuple with the Mobile field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactCreatable) GetMobileOk() (*string, bool) {
	if o == nil || IsNil(o.Mobile) {
		return nil, false
	}
	return o.Mobile, true
}

// HasMobile returns a boolean if a field has been set.
func (o *ContactCreatable) HasMobile() bool {
	if o != nil && !IsNil(o.Mobile) {
		return true
	}

	return false
}

// SetMobile gets a reference to the given string and assigns it to the Mobile field.
func (o *ContactCreatable) SetMobile(v string) {
	o.Mobile = &v
}

// GetMobileVerified returns the MobileVerified field value if set, zero value otherwise.
func (o *ContactCreatable) GetMobileVerified() bool {
	if o == nil || IsNil(o.MobileVerified) {
		var ret bool
		return ret
	}
	return *o.MobileVerified
}

// GetMobileVerifiedOk returns a tuple with the MobileVerified field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactCreatable) GetMobileVerifiedOk() (*bool, bool) {
	if o == nil || IsNil(o.MobileVerified) {
		return nil, false
	}
	return o.MobileVerified, true
}

// HasMobileVerified returns a boolean if a field has been set.
func (o *ContactCreatable) HasMobileVerified() bool {
	if o != nil && !IsNil(o.MobileVerified) {
		return true
	}

	return false
}

// SetMobileVerified gets a reference to the given bool and assigns it to the MobileVerified field.
func (o *ContactCreatable) SetMobileVerified(v bool) {
	o.MobileVerified = &v
}

// GetFirstName returns the FirstName field value if set, zero value otherwise.
func (o *ContactCreatable) GetFirstName() string {
	if o == nil || IsNil(o.FirstName) {
		var ret string
		return ret
	}
	return *o.FirstName
}

// GetFirstNameOk returns a tuple with the FirstName field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactCreatable) GetFirstNameOk() (*string, bool) {
	if o == nil || IsNil(o.FirstName) {
		return nil, false
	}
	return o.FirstName, true
}

// HasFirstName returns a boolean if a field has been set.
func (o *ContactCreatable) HasFirstName() bool {
	if o != nil && !IsNil(o.FirstName) {
		return true
	}

	return false
}

// SetFirstName gets a reference to the given string and assigns it to the FirstName field.
func (o *ContactCreatable) SetFirstName(v string) {
	o.FirstName = &v
}

// GetLastName returns the LastName field value if set, zero value otherwise.
func (o *ContactCreatable) GetLastName() string {
	if o == nil || IsNil(o.LastName) {
		var ret string
		return ret
	}
	return *o.LastName
}

// GetLastNameOk returns a tuple with the LastName field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactCreatable) GetLastNameOk() (*string, bool) {
	if o == nil || IsNil(o.LastName) {
		return nil, false
	}
	return o.LastName, true
}

// HasLastName returns a boolean if a field has been set.
func (o *ContactCreatable) HasLastName() bool {
	if o != nil && !IsNil(o.LastName) {
		return true
	}

	return false
}

// SetLastName gets a reference to the given string and assigns it to the LastName field.
func (o *ContactCreatable) SetLastName(v string) {
	o.LastName = &v
}

// GetEmail returns the Email field value if set, zero value otherwise.
func (o *ContactCreatable) GetEmail() string {
	if o == nil || IsNil(o.Email) {
		var ret string
		return ret
	}
	return *o.Email
}

// GetEmailOk returns a tuple with the Email field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactCreatable) GetEmailOk() (*string, bool) {
	if o == nil || IsNil(o.Email) {
		return nil, false
	}
	return o.Email, true
}

// HasEmail returns a boolean if a field has been set.
func (o *ContactCreatable) HasEmail() bool {
	if o != nil && !IsNil(o.Email) {
		return true
	}

	return false
}

// SetEmail gets a reference to the given string and assigns it to the Email field.
func (o *ContactCreatable) SetEmail(v string) {
	o.Email = &v
}

// GetGender returns the Gender field value if set, zero value otherwise.
func (o *ContactCreatable) GetGender() string {
	if o == nil || IsNil(o.Gender) {
		var ret string
		return ret
	}
	return *o.Gender
}

// GetGenderOk returns a tuple with the Gender field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactCreatable) GetGenderOk() (*string, bool) {
	if o == nil || IsNil(o.Gender) {
		return nil, false
	}
	return o.Gender, true
}

// HasGender returns a boolean if a field has been set.
func (o *ContactCreatable) HasGender() bool {
	if o != nil && !IsNil(o.Gender) {
		return true
	}

	return false
}

// SetGender gets a reference to the given string and assigns it to the Gender field.
func (o *ContactCreatable) SetGender(v string) {
	o.Gender = &v
}

// GetBirthdate returns the Birthdate field value if set, zero value otherwise.
func (o *ContactCreatable) GetBirthdate() string {
	if o == nil || IsNil(o.Birthdate) {
		var ret string
		return ret
	}
	return *o.Birthdate
}

// GetBirthdateOk returns a tuple with the Birthdate field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactCreatable) GetBirthdateOk() (*string, bool) {
	if o == nil || IsNil(o.Birthdate) {
		return nil, false
	}
	return o.Birthdate, true
}

// HasBirthdate returns a boolean if a field has been set.
func (o *ContactCreatable) HasBirthdate() bool {
	if o != nil && !IsNil(o.Birthdate) {
		return true
	}

	return false
}

// SetBirthdate gets a reference to the given string and assigns it to the Birthdate field.
func (o *ContactCreatable) SetBirthdate(v string) {
	o.Birthdate = &v
}

// GetMonthOfBirth returns the MonthOfBirth field value if set, zero value otherwise.
func (o *ContactCreatable) GetMonthOfBirth() int32 {
	if o == nil || IsNil(o.MonthOfBirth) {
		var ret int32
		return ret
	}
	return *o.MonthOfBirth
}

// GetMonthOfBirthOk returns a tuple with the MonthOfBirth field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactCreatable) GetMonthOfBirthOk() (*int32, bool) {
	if o == nil || IsNil(o.MonthOfBirth) {
		return nil, false
	}
	return o.MonthOfBirth, true
}

// HasMonthOfBirth returns a boolean if a field has been set.
func (o *ContactCreatable) HasMonthOfBirth() bool {
	if o != nil && !IsNil(o.MonthOfBirth) {
		return true
	}

	return false
}

// SetMonthOfBirth gets a reference to the given int32 and assigns it to the MonthOfBirth field.
func (o *ContactCreatable) SetMonthOfBirth(v int32) {
	o.MonthOfBirth = &v
}

// GetDayOfBirth returns the DayOfBirth field value if set, zero value otherwise.
func (o *ContactCreatable) GetDayOfBirth() int32 {
	if o == nil || IsNil(o.DayOfBirth) {
		var ret int32
		return ret
	}
	return *o.DayOfBirth
}

// GetDayOfBirthOk returns a tuple with the DayOfBirth field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactCreatable) GetDayOfBirthOk() (*int32, bool) {
	if o == nil || IsNil(o.DayOfBirth) {
		return nil, false
	}
	return o.DayOfBirth, true
}

// HasDayOfBirth returns a boolean if a field has been set.
func (o *ContactCreatable) HasDayOfBirth() bool {
	if o != nil && !IsNil(o.DayOfBirth) {
		return true
	}

	return false
}

// SetDayOfBirth gets a reference to the given int32 and assigns it to the DayOfBirth field.
func (o *ContactCreatable) SetDayOfBirth(v int32) {
	o.DayOfBirth = &v
}

// GetAddress returns the Address field value if set, zero value otherwise.
func (o *ContactCreatable) GetAddress() ContactAddress {
	if o == nil || IsNil(o.Address) {
		var ret ContactAddress
		return ret
	}
	return *o.Address
}

// GetAddressOk returns a tuple with the Address field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactCreatable) GetAddressOk() (*ContactAddress, bool) {
	if o == nil || IsNil(o.Address) {
		return nil, false
	}
	return o.Address, true
}

// HasAddress returns a boolean if a field has been set.
func (o *ContactCreatable) HasAddress() bool {
	if o != nil && !IsNil(o.Address) {
		return true
	}

	return false
}

// SetAddress gets a reference to the given ContactAddress and assigns it to the Address field.
func (o *ContactCreatable) SetAddress(v ContactAddress) {
	o.Address = &v
}

// GetLoyaltyPoints returns the LoyaltyPoints field value if set, zero value otherwise.
func (o *ContactCreatable) GetLoyaltyPoints() map[string]int32 {
	if o == nil || IsNil(o.LoyaltyPoints) {
		var ret map[string]int32
		return ret
	}
	return *o.LoyaltyPoints
}

// GetLoyaltyPointsOk returns a tuple with the LoyaltyPoints field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactCreatable) GetLoyaltyPointsOk() (*map[string]int32, bool) {
	if o == nil || IsNil(o.LoyaltyPoints) {
		return nil, false
	}
	return o.LoyaltyPoints, true
}

// HasLoyaltyPoints returns a boolean if a field has been set.
func (o *ContactCreatable) HasLoyaltyPoints() bool {
	if o != nil && !IsNil(o.LoyaltyPoints) {
		return true
	}

	return false
}

// SetLoyaltyPoints gets a reference to the given map[string]int32 and assigns it to the LoyaltyPoints field.
func (o *ContactCreatable) SetLoyaltyPoints(v map[string]int32) {
	o.LoyaltyPoints = &v
}

// GetLifetimeLoyaltyPoints returns the LifetimeLoyaltyPoints field value if set, zero value otherwise.
func (o *ContactCreatable) GetLifetimeLoyaltyPoints() map[string]int32 {
	if o == nil || IsNil(o.LifetimeLoyaltyPoints) {
		var ret map[string]int32
		return ret
	}
	return *o.LifetimeLoyaltyPoints
}

// GetLifetimeLoyaltyPointsOk returns a tuple with the LifetimeLoyaltyPoints field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactCreatable) GetLifetimeLoyaltyPointsOk() (*map[string]int32, bool) {
	if o == nil || IsNil(o.LifetimeLoyaltyPoints) {
		return nil, false
	}
	return o.LifetimeLoyaltyPoints, true
}

// HasLifetimeLoyaltyPoints returns a boolean if a field has been set.
func (o *ContactCreatable) HasLifetimeLoyaltyPoints() bool {
	if o != nil && !IsNil(o.LifetimeLoyaltyPoints) {
		return true
	}

	return false
}

// SetLifetimeLoyaltyPoints gets a reference to the given map[string]int32 and assigns it to the LifetimeLoyaltyPoints field.
func (o *ContactCreatable) SetLifetimeLoyaltyPoints(v map[string]int32) {
	o.LifetimeLoyaltyPoints = &v
}

// GetLanguages returns the Languages field value if set, zero value otherwise.
func (o *ContactCreatable) GetLanguages() ContactLanguages {
	if o == nil || IsNil(o.Languages) {
		var ret ContactLanguages
		return ret
	}
	return *o.Languages
}

// GetLanguagesOk returns a tuple with the Languages field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactCreatable) GetLanguagesOk() (*ContactLanguages, bool) {
	if o == nil || IsNil(o.Languages) {
		return nil, false
	}
	return o.Languages, true
}

// HasLanguages returns a boolean if a field has been set.
func (o *ContactCreatable) HasLanguages() bool {
	if o != nil && !IsNil(o.Languages) {
		return true
	}

	return false
}

// SetLanguages gets a reference to the given ContactLanguages and assigns it to the Languages field.
func (o *ContactCreatable) SetLanguages(v ContactLanguages) {
	o.Languages = &v
}

// GetCareOf returns the CareOf field value if set, zero value otherwise.
func (o *ContactCreatable) GetCareOf() string {
	if o == nil || IsNil(o.CareOf) {
		var ret string
		return ret
	}
	return *o.CareOf
}

// GetCareOfOk returns a tuple with the CareOf field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactCreatable) GetCareOfOk() (*string, bool) {
	if o == nil || IsNil(o.CareOf) {
		return nil, false
	}
	return o.CareOf, true
}

// HasCareOf returns a boolean if a field has been set.
func (o *ContactCreatable) HasCareOf() bool {
	if o != nil && !IsNil(o.CareOf) {
		return true
	}

	return false
}

// SetCareOf gets a reference to the given string and assigns it to the CareOf field.
func (o *ContactCreatable) SetCareOf(v string) {
	o.CareOf = &v
}

// GetStrictAttributes returns the StrictAttributes field value if set, zero value otherwise.
func (o *ContactCreatable) GetStrictAttributes() map[string]interface{} {
	if o == nil || IsNil(o.StrictAttributes) {
		var ret map[string]interface{}
		return ret
	}
	return o.StrictAttributes
}

// GetStrictAttributesOk returns a tuple with the StrictAttributes field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactCreatable) GetStrictAttributesOk() (map[string]interface{}, bool) {
	if o == nil || IsNil(o.StrictAttributes) {
		return map[string]interface{}{}, false
	}
	return o.StrictAttributes, true
}

// HasStrictAttributes returns a boolean if a field has been set.
func (o *ContactCreatable) HasStrictAttributes() bool {
	if o != nil && !IsNil(o.StrictAttributes) {
		return true
	}

	return false
}

// SetStrictAttributes gets a reference to the given map[string]interface{} and assigns it to the StrictAttributes field.
func (o *ContactCreatable) SetStrictAttributes(v map[string]interface{}) {
	o.StrictAttributes = v
}

// GetMobileVerifiedAt returns the MobileVerifiedAt field value if set, zero value otherwise.
func (o *ContactCreatable) GetMobileVerifiedAt() time.Time {
	if o == nil || IsNil(o.MobileVerifiedAt) {
		var ret time.Time
		return ret
	}
	return *o.MobileVerifiedAt
}

// GetMobileVerifiedAtOk returns a tuple with the MobileVerifiedAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactCreatable) GetMobileVerifiedAtOk() (*time.Time, bool) {
	if o == nil || IsNil(o.MobileVerifiedAt) {
		return nil, false
	}
	return o.MobileVerifiedAt, true
}

// HasMobileVerifiedAt returns a boolean if a field has been set.
func (o *ContactCreatable) HasMobileVerifiedAt() bool {
	if o != nil && !IsNil(o.MobileVerifiedAt) {
		return true
	}

	return false
}

// SetMobileVerifiedAt gets a reference to the given time.Time and assigns it to the MobileVerifiedAt field.
func (o *ContactCreatable) SetMobileVerifiedAt(v time.Time) {
	o.MobileVerifiedAt = &v
}

// GetAvatars returns the Avatars field value if set, zero value otherwise.
func (o *ContactCreatable) GetAvatars() ContactAvatars {
	if o == nil || IsNil(o.Avatars) {
		var ret ContactAvatars
		return ret
	}
	return *o.Avatars
}

// GetAvatarsOk returns a tuple with the Avatars field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactCreatable) GetAvatarsOk() (*ContactAvatars, bool) {
	if o == nil || IsNil(o.Avatars) {
		return nil, false
	}
	return o.Avatars, true
}

// HasAvatars returns a boolean if a field has been set.
func (o *ContactCreatable) HasAvatars() bool {
	if o != nil && !IsNil(o.Avatars) {
		return true
	}

	return false
}

// SetAvatars gets a reference to the given ContactAvatars and assigns it to the Avatars field.
func (o *ContactCreatable) SetAvatars(v ContactAvatars) {
	o.Avatars = &v
}

// GetExternalIds returns the ExternalIds field value if set, zero value otherwise.
func (o *ContactCreatable) GetExternalIds() map[string]interface{} {
	if o == nil || IsNil(o.ExternalIds) {
		var ret map[string]interface{}
		return ret
	}
	return o.ExternalIds
}

// GetExternalIdsOk returns a tuple with the ExternalIds field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactCreatable) GetExternalIdsOk() (map[string]interface{}, bool) {
	if o == nil || IsNil(o.ExternalIds) {
		return map[string]interface{}{}, false
	}
	return o.ExternalIds, true
}

// HasExternalIds returns a boolean if a field has been set.
func (o *ContactCreatable) HasExternalIds() bool {
	if o != nil && !IsNil(o.ExternalIds) {
		return true
	}

	return false
}

// SetExternalIds gets a reference to the given map[string]interface{} and assigns it to the ExternalIds field.
func (o *ContactCreatable) SetExternalIds(v map[string]interface{}) {
	o.ExternalIds = v
}

func (o ContactCreatable) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ContactCreatable) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["name"] = o.Name
	if !IsNil(o.Timezone) {
		toSerialize["timezone"] = o.Timezone
	}
	if !IsNil(o.Mobile) {
		toSerialize["mobile"] = o.Mobile
	}
	if !IsNil(o.MobileVerified) {
		toSerialize["mobile_verified"] = o.MobileVerified
	}
	if !IsNil(o.FirstName) {
		toSerialize["first_name"] = o.FirstName
	}
	if !IsNil(o.LastName) {
		toSerialize["last_name"] = o.LastName
	}
	if !IsNil(o.Email) {
		toSerialize["email"] = o.Email
	}
	if !IsNil(o.Gender) {
		toSerialize["gender"] = o.Gender
	}
	if !IsNil(o.Birthdate) {
		toSerialize["birthdate"] = o.Birthdate
	}
	if !IsNil(o.MonthOfBirth) {
		toSerialize["month_of_birth"] = o.MonthOfBirth
	}
	if !IsNil(o.DayOfBirth) {
		toSerialize["day_of_birth"] = o.DayOfBirth
	}
	if !IsNil(o.Address) {
		toSerialize["address"] = o.Address
	}
	if !IsNil(o.LoyaltyPoints) {
		toSerialize["loyalty_points"] = o.LoyaltyPoints
	}
	if !IsNil(o.LifetimeLoyaltyPoints) {
		toSerialize["lifetime_loyalty_points"] = o.LifetimeLoyaltyPoints
	}
	if !IsNil(o.Languages) {
		toSerialize["languages"] = o.Languages
	}
	if !IsNil(o.CareOf) {
		toSerialize["care_of"] = o.CareOf
	}
	if !IsNil(o.StrictAttributes) {
		toSerialize["strict_attributes"] = o.StrictAttributes
	}
	if !IsNil(o.MobileVerifiedAt) {
		toSerialize["mobile_verified_at"] = o.MobileVerifiedAt
	}
	if !IsNil(o.Avatars) {
		toSerialize["avatars"] = o.Avatars
	}
	if !IsNil(o.ExternalIds) {
		toSerialize["external_ids"] = o.ExternalIds
	}
	return toSerialize, nil
}

type NullableContactCreatable struct {
	value *ContactCreatable
	isSet bool
}

func (v NullableContactCreatable) Get() *ContactCreatable {
	return v.value
}

func (v *NullableContactCreatable) Set(val *ContactCreatable) {
	v.value = val
	v.isSet = true
}

func (v NullableContactCreatable) IsSet() bool {
	return v.isSet
}

func (v *NullableContactCreatable) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableContactCreatable(val *ContactCreatable) *NullableContactCreatable {
	return &NullableContactCreatable{value: val, isSet: true}
}

func (v NullableContactCreatable) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableContactCreatable) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


